VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStatusBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'################################################################################
' Modul        : clsStatusBar
' Beschreibung : ComClt32.ocx Replacement
'                fr die StatusBar
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Sonntag, 15. September 2002
'
' Copyright (C) 2002 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Chris_vw@web.de

Private Const WM_USER As Long = 1024&
Private Const SB_GETPARTS As Long = (WM_USER + 6)
Private Const SB_SETPARTS As Long = (WM_USER + 4)
Private Const SB_GETRECT As Long = (WM_USER + 10)

Public Enum sbStyles
    sbNormal = 0
    sbSimple = 1
End Enum

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type InitCommonControlsEx
    dwSize As Long 'size of this structure
    dwICC As Long 'flags indicating which classes to be initialized
End Type

'COMCTL32
Private Declare Function CreateStatusWindow Lib "comctl32.dll" _
        (ByVal Style As Long, ByVal lpszText As String, ByVal _
        hWndParent As Long, ByVal wID As Long) As Long
        
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" _
        (ByRef TLPINITCOMMONCONTROLSEX As InitCommonControlsEx) _
        As Long


'USER32
Private Declare Function SendMessage Lib "user32.dll" Alias _
        "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, _
        ByVal wParam As Long, lParam As Any) As Long
        
Private Declare Function MoveWindow Lib "user32.dll" (ByVal _
        hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As _
        Long) As Long
        
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal _
        hwnd As Long, lpRect As RECT) As Long
        
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal _
        hwnd As Long) As Long

Private Declare Function SetWindowPos Lib "user32" _
        (ByVal hwnd As Long, ByVal hWndInsertAfter As Long _
        , ByVal x As Long, ByVal y As Long, ByVal cx As Long, _
        ByVal cy As Long, ByVal wFlags As Long) As Long

Const SWP_SHOWWINDOW = &H40
Const SWP_HIDEWINDOW = &H80

Public hwnd As Long
Private m_Text As String
Private m_Style As sbStyles
Private m_Panels() As Long
Private m_oldWidth As Long
Private m_Visible As Boolean

Private Sub Class_Initialize()
    Dim InitCC As InitCommonControlsEx
    InitCC.dwICC = &H4
    InitCC.dwSize = Len(InitCC)
    InitCommonControlsEx InitCC
    m_Style = sbNormal
    ReDim m_Panels(0)
End Sub

Public Sub Create(mParent As Object)
    hwnd = CreateStatusWindow(&H40000000 Or &H10000000 Or &H10&, "", mParent.hwnd, 200)
    m_Visible = True
End Sub

Public Sub Resize(mParent As Object)
    Dim R As RECT
    GetWindowRect hwnd, R
    MoveWindow hwnd, 0, mParent.ScaleHeight - (R.Bottom - R.Top), mParent.ScaleWidth, mParent.ScaleHeight - (R.Bottom - R.Top), True
End Sub

Public Property Let Text(mText As String)
    Dim mByte() As Byte
    mByte() = mText & Chr(0)
    #If UNICODE Then
        SendMessage hwnd, 1025, 255, mByte(0)
    #Else
        SendMessage hwnd, 1035, 255, mByte(0)
    #End If
    m_Text = mText
End Property

Public Property Get Text() As String
    Text = m_Text
End Property

Public Property Let Style(mStyle As sbStyles)
    SendMessage hwnd, 1033, mStyle, 0
    m_Style = mStyle
End Property

Public Property Get Style() As sbStyles
    Style = m_Style
End Property

Public Property Let PanelWidth(mPanel As Long, mWidth As Long)
    Dim mW As Long
    If (mWidth < 0) Or (mWidth > 255) Then mWidth = -1
    If (mPanel >= CByte(SendMessage(hwnd, SB_GETPARTS, 1, 0))) Then
        ReDim Preserve m_Panels(mPanel - 1)
        If mWidth = -1 Then m_oldWidth = 0
        m_Panels(mPanel - 1) = m_oldWidth + mWidth
        m_oldWidth = mWidth
    End If
    SendMessage hwnd, SB_SETPARTS, mPanel, m_Panels(0)
End Property

Public Property Let PanelText(mPanel As Long, mText As String)
    Dim mByte() As Byte
    mByte() = mText & Chr(0)
    #If UNICODE Then
        SendMessage hwnd, 1025, mPanel - 1, mByte(0)
    #Else
        SendMessage hwnd, 1035, mPanel - 1, mByte(0)
    #End If
End Property

Public Property Let MinHeight(mHeight As Long)
    SendMessage hwnd, 1032, mHeight, 0
End Property

Public Property Get PanelCount() As Byte
    PanelCount = CByte(SendMessage(hwnd, 1030, 1, 0))
End Property

Public Property Get Height() As Long
    Dim R As RECT
    SendMessage hwnd, 1034, 0, R
    Height = (R.Bottom - R.Top) * Screen.TwipsPerPixelY
End Property

Private Sub Class_Terminate()
    DestroyWindow hwnd
End Sub


Public Property Get PanelWidth(mPanel As Long) As Long
    Dim R As RECT, Result As Long
    
        If SendMessage(hwnd, SB_GETRECT, mPanel - 1, R) Then PanelWidth = R.Right - R.Left
End Property

Public Property Get PanelHeight(mPanel As Long) As Long
    Dim R As RECT, Result As Long
    
        If SendMessage(hwnd, SB_GETRECT, mPanel - 1, R) Then PanelHeight = R.Bottom - R.Top
End Property

Public Property Get PanelLeft(mPanel As Long) As Long
    Dim R As RECT, Result As Long
    
        If SendMessage(hwnd, SB_GETRECT, mPanel - 1, R) Then PanelLeft = R.Left
End Property

Public Property Get PanelTop(mPanel As Long) As Long
    Dim R As RECT, Result As Long
    
        If SendMessage(hwnd, SB_GETRECT, mPanel - 1, R) Then PanelTop = R.Top
End Property

Public Property Get Visible() As Boolean
    Visible = m_Visible
End Property

Public Property Let Visible(n_Visible As Boolean)
    If n_Visible <> m_Visible Then
        m_Visible = n_Visible
        
        If m_Visible Then
            Call SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_SHOWWINDOW)
        Else
            Call SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW)
        End If
    End If
End Property


