Attribute VB_Name = "modSubclass"
Option Explicit
              
Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal _
        hwnd As Long, ByVal MSG As Long, ByVal wParam As _
        Long, ByVal lParam As Long) As Long
        
Private Declare Function SetWindowLong Lib "user32" Alias _
        "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
        As Long, ByVal dwNewLong As Long) As Long
       
Private Declare Function GetMenuString Lib "user32" Alias _
        "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem _
        As Long, ByVal lpString As String, ByVal nMaxCount As _
        Long, ByVal wFlag As Long) As Long

Private Declare Function GetSubMenu Lib "user32" (ByVal _
        hMenu As Long, ByVal nPos As Long) As Long
               
Private Declare Function GetMenu Lib "user32" (ByVal _
        hwnd As Long) As Long
        
Private Declare Function SetMenuDefaultItem Lib "user32" _
        (ByVal hMenu As Long, ByVal uItem As Long, ByVal _
        fByPos As Long) As Long
        
        
Private Const MF_GRAYED = &H1&
Private Const MF_DISABLED = &H2&
Private Const MF_POPUP As Long = &H10&
Private Const MF_SEPARATOR = &H800&

Private Const WM_MENUSELECT As Long = &H11F
Private Const WM_DESTROY  As Long = &H2
Private Const GWL_WNDPROC As Long = (-4&)

Private PrevWndProc As Long
Private PrevMnuProc As Long

Private xhWnd As Long
Private Initialized As Boolean

Private Const MN_REG_MAIN As Long = 0
Private Const MN_REG_EDIT As Long = 1
Private Const MN_REG_VIEW As Long = 2
Private Const MN_REG_FAVO As Long = 3
Private Const MN_REG_HELP As Long = 4

Private Const MN_REG_TREE As Long = 5
Private Const MN_REG_LIST As Long = 6
Private Const MN_REG_OVAL As Long = 7

Private Const MN_REG_IMPO As Long = 2
Private Const MN_REG_EXPO As Long = 3
Private Const MN_REG_CONN As Long = 5
Private Const MN_REG_DISC As Long = 6
Private Const MN_REG_PRNT As Long = 8
Private Const MN_REG_QUIT As Long = 10

Private Const MN_EDT_CHNG As Long = 12
Private Const MN_EDT_NKEY As Long = 15
Private Const MN_EDT_NSTR As Long = 17
Private Const MN_EDT_NBIN As Long = 18
Private Const MN_EDT_NWRD As Long = 19
Private Const MN_EDT_DELT As Long = 21
Private Const MN_EDT_NAME As Long = 22
Private Const MN_EDT_COPY As Long = 24
Private Const MN_EDT_SEAR As Long = 26
Private Const MN_EDT_NEXT As Long = 27

Private Const MN_EDT_STAB As Long = 29
Private Const MN_EDT_DVDE As Long = 31
Private Const MN_EDT_RFRS As Long = 33

Private Const MN_FAV_ADDF As Long = 35
Private Const MN_FAV_DELF As Long = 36

Private Const MN_HLP_HELP As Long = 54
Private Const MN_HLP_INFO As Long = 56

Private Function SubWndProc(ByVal hwnd As Long, ByVal MSG As Long, _
                            ByVal wParam As Long, ByVal lParam As _
                            Long) As Long
                            
    Dim Lo As Long, Hi As Long
   
        If MSG = WM_DESTROY Then
            Call Terminate
        ElseIf MSG = WM_MENUSELECT Then
            Hi = Int(wParam / 65536)
            Lo = wParam - Hi * 65536
            If Hi < 0 Then Hi = Hi + 65536 'Evt Komplement bilden
            
            frmRegistry.sbBottom.PanelText(2) = GetHelpTextFromMenuItem(lParam, Lo, Hi)
        End If

        SubWndProc = CallWindowProc(PrevWndProc, hwnd, MSG, wParam, lParam)
End Function

Public Sub Init(hwnd As Long)
    PrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf SubWndProc)
    xhWnd = hwnd
    Initialized = True
    Call MakeDefaultItems
    
    If IsIDE Then
        Call MsgBox("Dieses Beispiel verwendet Subclassing" & vbCrLf & "Daher bitte nicht ber die IDE beenden" & vbCrLf & "oder aber das Programm als Exe starten.", vbOKOnly Or vbInformation, "Hinweis")
    End If
End Sub

Public Sub Terminate()
    If Initialized Then Call SetWindowLong(xhWnd, GWL_WNDPROC, PrevWndProc)
End Sub

Private Function GetHelpTextFromMenuItem(hMenu As Long, hItem As Long, Flags As Long) As String
    Dim Result As String
        
        If hMenu = 0 Then
            'Men wurde geschlossen
            Result = ""
        ElseIf (Flags And MF_POPUP) Then
            'Obermen
            If hMenu = GetMenu(frmRegistry.hwnd) Then
                Select Case hItem
                    Case MN_REG_MAIN: Result = "Befehle zum Bearbeiten der gesamten Registrierung."
                    Case MN_REG_EDIT: Result = "Befehle zum Bearbeiten von Werten und Schlsseln."
                    Case MN_REG_VIEW: Result = "Befehle zum Anpassen des Registrierungsfensters."
                    Case MN_REG_FAVO: Result = "Befehle fr den Zugriff auf hufig verwendete Schlssel."
                    Case MN_REG_HELP: Result = "Befehle zum Anzeigen der Hilfe und von Informationen ber den Registrierungs-Editor."
                End Select
            Else
                'SubMen "Neu"
                Result = "Befehle zum Erstellen von Werten oder Schlsseln."
            End If
        ElseIf (Flags And MF_SEPARATOR) Then
            'Seperator
            Result = ""
        Else
            'Normaler Menpunkt
            Select Case hItem
            
                '"Registrierung"-Men
                Case MN_REG_IMPO: Result = "Importiert Textdateien in die Registrierung."
                Case MN_REG_EXPO: Result = "Exportiert Registrierungsdaten in eine Textdatei."
                Case MN_REG_CONN: Result = "Stellt die Verbindung mit der Registrierung eines Remote-Computers her."
                Case MN_REG_DISC: Result = "Trennt die Verbindung mit der Registrierung eines Remote-Computers."
                Case MN_REG_PRNT: Result = "Druckt Registrierungsdaten"
                Case MN_REG_QUIT: Result = "Schliet den Registrierungs-Editor."
            
                '"Bearbeiten"-Men
                Case MN_EDT_CHNG: Result = "ndert die Daten eines Wertes."
                Case MN_EDT_DELT: Result = "Lscht die markierten Eintrge."
                Case MN_EDT_NKEY: Result = "Fgt einen neuen Schlssel hinzu."
                Case MN_EDT_NSTR: Result = "Fgt einen neuen Zeichenfolgenwert hinzu."
                Case MN_EDT_NBIN: Result = "Fgt einen neuen Binrwert hinzu."
                Case MN_EDT_NWRD: Result = "Fgt einen neuen DWORD-Wert hinzu."
                Case MN_EDT_NAME: Result = "Benennt die markierten Eintrge um."
                Case MN_EDT_COPY: Result = "Kopiert den Namen des gewhlten Schlssels in die Zwischenablage."
                Case MN_EDT_SEAR: Result = "Sucht eine Zeichenfolge in einem Schlssel, einem Wert oder in Daten."
                Case MN_EDT_NEXT: Result = "Sucht den nchsten Eintrag des gesuchten Texts."
                
                '"Ansicht"-Men
                Case MN_EDT_STAB: Result = "Blendet die Statusleiste aus oder ein."
                Case MN_EDT_DVDE: Result = "ndert die Position des Fensterteilers."
                Case MN_EDT_RFRS: Result = "Aktualisiert das Fenster."
                
                '"Favoriten"-Men
                Case MN_FAV_ADDF: Result = "Fgt Schlssel zu der Favoritenliste hinzu."
                Case MN_FAV_DELF: Result = "Entfernt Schlssel aus der Favoritenliste."
                
                '"?"-Men
                Case MN_HLP_HELP: Result = "ffnet die Hilfe des Registrierungs-Editors."
                Case MN_HLP_INFO: Result = "Zeigt Programminformationen, Versionsnummer und Copyright-Informationen an."
            End Select

        End If

        GetHelpTextFromMenuItem = Result
End Function

Public Function MakeDefaultItems()
    Dim mnuMainHandle As Long, mnuHandle As Long
        
        mnuMainHandle& = GetMenu(frmRegistry.hwnd)
        
        mnuHandle = GetSubMenu(mnuMainHandle, MN_EDT_CHNG)
        Call SetMenuDefaultItem(mnuHandle, 0&, 1&)
        
        mnuHandle = GetSubMenu(mnuMainHandle, MN_REG_TREE)
        Call SetMenuDefaultItem(mnuHandle, 0&, 1&)
        
        mnuHandle = GetSubMenu(mnuMainHandle, MN_REG_OVAL)
        Call SetMenuDefaultItem(mnuHandle, 0&, 1&)
End Function

Public Function IsIDE() As Boolean
    On Error GoTo Err
    
    Debug.Print 1 / 0
    
    Exit Function

Err:
    IsIDE = True
End Function
